#include <cstdio>

void printChars(int k, char ch1, char ch2) {
    for (int i = 0; i < k; ++i) {
        printf("%c", (i & 1) ? ch1 : ch2);
    }
}

int main() {
    freopen("pwgen.in", "r", stdin);
    freopen("pwgen.out", "w", stdout);

    int big, small, digit, n;
    scanf("%d%d%d%d", &n, &big, &small, &digit);
    if (big + small + digit > n) {
        throw 42;
    }
    digit = n - big - small;
    printChars(big, 'A', 'B');
    printChars(small, 'a', 'b');
    printChars(digit, '0', '1');
    return 0;
}